/* Pre: a=A */
int mida(Arbre<int>& a)
{
  int n;
  if (a.es_buit()) n=0;
  else{
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    int n1=mida(a1);
    //{HI1: n1= "mida del fill esquerra d'A" }
    int n2=mida(a2);
    //{HI2: n2= "mida del fill dret d'A" }
    n = n1 + n2 + 1;
  }
/* n= "mida d'A" */
  return n;
}
/* Post: retorna la mida d'A */


/* 

Justificació:

1) Cas senzill.

Si A és buit no té cap node i per tant la mida és 0.

2) Cas resursiu.

Les crides són correctes. Com que no és buit, A té fill esquerra i
fill dret. Per inducció tenim HI1 i HI2. Així, com que el fill
esquerre d'A té n1 nodes i el fill dret té n2 nodes, A té n1+ n2 + 1
nodes, ja que també hem de comptar l'arrel.

3) Acabament.

Decreix la mida d'a, ja que tant a1 com a2 tenen com a mínim un node
menys.

*/

